<!DOCTYPE html>
<html>
  <head>
    <title>Documenter avec gitlab</title>
    <meta charset="utf-8">
    <base target="_blank">
    <meta name="author" content="Joris Navarro">
    <style>
      @import url(https://fonts.googleapis.com/css?family=Yanone+Kaffeesatz);
      @import url(https://fonts.googleapis.com/css?family=Droid+Serif:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Droid Serif'; 
        color: #444;
      }
      h1, h2, h3 {
        font-family: 'Yanone Kaffeesatz';
        font-weight: normal;
        color: #3e3e3e;
      }
      .small-img img{
        width: 90%;
        max-height: 90%;
      }
      .full-width img{
        width: 100%;
        margin-right: 5%;
      }
      .tall-img img {
        
        height: 400px;
      }
      .logo img {
        max-width: 400px;
      }
      .logo_tiny img {
        margin-top: 100px;
        max-width: 200px;
      }
      .logo_micro img {
        vertical-align: bottom;
        max-width: 60px;
      }

      .small_text{
        font-size: small;
      }

      .remark-code, .remark-inline-code { font-family: 'Ubuntu Mono'; }
      .bordered {
        border: 1px solid #dedede;
        margin-right: 24px;
        width: 80%;
      }
    </style>
  </head>
  <body>
    <textarea id="source">

class: center, middle        


.logo[![](img/nuitdesmakers.png)]

---

class: center, middle

_Samedi 10 Octobre 2020_

# Documenter avec Gitlab 

_(Niveau Débutants, et en français)_

**Joris Navarro**

[joris.navarro@gmail.com](mailto:joris.navarro@gmail.com)

.logo_tiny[
![](img/squaregolab.png)
]
---
class: left, top 

## Agenda

#### Documenter ?​
* Pourquoi ?​
* Comment ? ​

#### Version Control & GitLab​
* Version control​
* Git​
* GitLab​

#### GitLab en pratique​
* Les repositories​
* Markdown​
* Issues​, Merge requests
* Plus loin avec Pages, CI/CD & Jekyll​

---

## Documenter ? Pourquoi ?​


### Pour qui ?​

* Pour moi !!
* et pour les autres ...


### Les besoins ?

* l'information
* accessibilité
* ergonomies
* tracabilité
* collaboration

---

## Documenter ? Comment ?​

### Vidéos (audio)

<!-- <video width="80%" controls> 
    <source src="https://gitlab.fabcloud.org/academany/fabacademy/2018/labs/barcelona/students/joris-navarro/-/raw/master/assets/images/classes/08/cnc.mp4" type="video/mp4">Your browser does not support the video tag.
</video> -->
<iframe width="560" height="315" src="https://www.youtube.com/embed/twSk8BreSqs" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>

 * hebergement (plateformes, self-hosting)
 * indexation/recherche
 
---

## Documenter ? Comment ?​

### Photos

<table>
    <tr>
        <td width="30%"><img style="max-width:100%;" src="https://gitlab.fabcloud.org/academany/fabacademy/2018/labs/barcelona/students/joris-navarro/-/raw/master/assets/images/classes/08/finaldesign.PNG"></td>
        <td width="30%"><img style="max-width:100%;" src="https://gitlab.fabcloud.org/academany/fabacademy/2018/labs/barcelona/students/joris-navarro/-/raw/master/assets/images/classes/08/S0.PNG"></td>
        <td width="30%"><img style="max-width:100%;" src="https://gitlab.fabcloud.org/academany/fabacademy/2018/labs/barcelona/students/joris-navarro/-/raw/master/assets/images/classes/08/shopbot_job.jpg"></td>
    </tr>
</table>

---

## Documenter ? Comment ?​

### Texte

  * language (fr, en, ...)
  * Docx ? odt ? pdf ?
  * [pads hebergés](https://framapad.org/fr/)
  * wikis

---

  ## Documenter ? Comment ?​
  
  ### All in one
    
   #### Html
   
   * language (fr, en, ...)
   * apprendre le html/css/js 
   * wysiwyg => plateformes dédiées ([instructables](https://www.instructables.com/Hydraulic-Craft-Stick-Box/), [wikifactory](https://projects.fablabs.io/) )
   * propre hébergement
   * redaction collaborative

---
  

   ### il nous faudrait un outil pour

   * gratuit et open
   * Rédiger à plusieurs
   * facilite la collaboration 
   * suivi et gestion de projet
   * herbergement de ressources
   * crée du contenu accesible (web)
   * gratuit et open ;)


   #### _mais comment font les projets open source ?_

---

background-image: url(img/versioncontrol.png)

## Outils de controle de version

### Version Control System (VCS)
---

## Version Control

* C'est quoi ?

`La gestion de versions (en anglais : version control ou revision control) consiste à gérer l'ensemble des versions d'un ou plusieurs fichiers (généralement en texte). Essentiellement utilisée dans le domaine de la création de logiciels, elle concerne surtout la gestion des codes source.`

.small_text[Source: [Wikipedia](https://fr.wikipedia.org/wiki/Gestion_de_versions)]

* Comment ?

    * Copie locale des fichiers
    * gestionaire local
    * gestionaire distant
    * gestionaire distribué

---

## Version Control - Git

* ça fait quoi ?​

    * hebergement des fichiers
    * historique des modifications
    * gestion des conflits
    * Branches et versions (restoration, sauvegardes, ...)

    et plus encore ...

    * projets et groupes de projets
    * droits (équipe, accessibilités)    
    * monitoring
    * automatisation (analyse, intégration, publication)
    * gestion & suivi (incidents, feuille de route, ...)
    * recherche avancée

    [et plus encore !](https://about.gitlab.com/features/)

---

## GitLab

<div style="float: right">
    <img src="img/gitlabvsgithub.png" style="width: 200px"><br/>
    <img src="img/git.png" style="width: 150px"><br/>
    <img src="img/fabcloud.png" style="width: 150px"><br/>
    </div>

 * Service basé sur Protocole Git VCS
 * Plateforme dédié au développement logiciel, mais pas que ...
 * open source, 
 * [cloud](https://gitlab.fabcloud.org/) vs [on premise](https://gitlab.squaregolab.com) vs [SAAS](https://gitlab.com/)
 * distribué
 * choisi par la communauté des fablabs ([gitlab.fabcloud.org](https://gitlab.fabcloud.org))
 * utilisé par des millions de personnes
 * github & bitbucket

 .small-img[
 ![](img/example1.png)
 ]

---

### Fonctionnement

.full-width[![fonctionnement](img/fonctionnement.png)]

---

### GitLab en pratique​

#### Les repositories​ 

* Les projets du Redlab : [https://gitlab.com/redlab_projects](https://gitlab.com/redlab_projects)
* creation d'un projet demo
* mettre des fichiers
* editer avec le webIDE

.full-width[![fonctionnement](img/awesome.png)]

---

### GitLab en pratique​
    
#### Markdown​ => MD

Exemples

```markdown
#### Ceci est un titre 4
_documenter en italique_

* liste à puce
* liste à puce

[Ce document est écrit en markdown](./..)
```

donne :

#### Ceci est un titre 4
_documenter en italique_

* liste à puce
* liste à puce

[Ce document est écrit en markdown](./..)
---

### GitLab en pratique​
    
#### Markdown​ => MD

Liens utiles:

* [Documentation officielle](https://daringfireball.net/projects/markdown/syntax) (en anglais)
* Aide mémoire [ici](https://support.squarespace.com/hc/fr-fr/articles/206543587-Aide-m%C3%A9moire-Markdown) ou [ici](https://support.zendesk.com/hc/fr/articles/203691016-Formatage-de-texte-avec-Markdown)
* [Un guide pour bien commencer](https://blog.wax-o.com/2014/04/tutoriel-un-guide-pour-bien-commencer-avec-markdown/)
* Formation [Openclassroom](https://openclassrooms.com/fr/courses/1304236-redigez-en-markdown)

---

### GitLab en pratique​
    
#### Issues​/Tickets/gestion de project

<div style="float: right">
    <img src="img/star.png" style="width: 200px">
</div>

* creation d'un projet actus du réseau (publiques)
* les notifications
* les threads de dicussions
* creation d'un projet Redlab (privé)
* les taches sont aussi des tickets
* Kanban, jalons, ....

.full-width[![fonctionnement](img/tickets.png)]

---

### GitLab en pratique​
    
#### Aller plus loin ... avec Gitlab Pages

* publiez une page web !
    * [Exemple : le projet test-ci](https://gitlab.com/redlab_projects/private/test_ci)
* écrite en md ?​
    * [remark pour les présentations](https://github.com/gnab/remark) - comme celle-ci !
    * [marked](https://github.com/markedjs/marked) - [demo](https://marked.js.org/demo/)

* Publier tout un site (statique bien sur) en utilisant un framework 
    * Jekyll sample : [repo](https://gitlab.com/pages/jekyll) - [site](https://pages.gitlab.io/jekyll/)
    * Jekyll (joris fabacademy): [repo](https://gitlab.fabcloud.org/academany/fabacademy/2018/labs/barcelona/students/joris-navarro) - [site](http://fabacademy.org/2018/labs/barcelona/students/joris-navarro/)
ou autres (non testés)
    * [middleman](https://gitlab.com/gitlab-org/project-templates/static-site-editor-middleman)
    * [Gatsby](https://gitlab.com/gitlab-org/project-templates/gatsby)
    * [Hugo (Tutoriel sur framasoft docs)](https://docs.framasoft.org/fr/gitlab/gitlab-pages.html)    

---

# Merci à tous pour votre attention

    </textarea>
    <script src="https://remarkjs.com/downloads/remark-latest.min.js">
    </script>
    <script>
      var slideshow = remark.create();
    </script>
  </body>
</html>
